function doCommand(command)
{
	lprint('command: ' + command);
	var result = runCommand(command);
	lprint('result:  ' + result);
	return result;
}

function escapePath(path) { return path.replace(/([\W])/g,'\\$1'); }

// calls used only on the Macintosh - never have been in Unix Utils
function getFileInfo(path) { return doCommand('file ' + escapePath(path)); }

filesystem.unixRM = function(path) { return filesystem.remove(path); };

function theURL(url, outputFile, referer)
{
	var myUrl = new URL();
	if (outputFile !== "") { myUrl.outputFile = outputFile; }
	if (referer    !== "") { myUrl.setRequestHeader( "Referer", referer ); }
	var result = myUrl.fetch(url);
	var resp = myUrl.response;
	lprint('theURL:resp=' + resp);
	if (outputFile !== "") { lprint('theURL:result=' + result); }
	var OK = ((resp == 200) || (resp === 0));	// resp === 0 for local files
	if (outputFile !== "")
	{
		if (OK) { return ""; } else { return 'Cannot fetch "' + url + '". HTTP Error code ' + resp + '.'; }
	}
	else
	{
		if (OK) { return result; } else { return ""; }
	}
}
