// Menu Class - using popupMenu(), 7 August, 2007, Copyright 2004-2007 Harry Whitfield

function Menu(menuImage, menuStringsArray, selectedString, menuActionFunction)
{
    this.image = menuImage;
    this.menus = [];
    for (var i = 0; i < menuStringsArray.length; i += 1) { this.menus[i] = menuStringsArray[i]; }
    this.selected = selectedString;
    this.menuAction = menuActionFunction;
    this.hOff = menuImage.hOffset;
    this.vOff = menuImage.vOffset;
}

Menu.prototype.reset = function( menuStringsArray, selectedString)
{
	this.menus = null;
	this.menus = [];
    for (var i = 0; i < menuStringsArray.length; i += 1) { this.menus[i] = menuStringsArray[i]; }
    this.selected = selectedString;
};

Menu.prototype.show = function(opacity) { this.image.opacity = opacity; };

Menu.prototype.setTick = function(selected) { this.selected = selected; };

Menu.prototype.select = function()
{
    var contextItems = new Array();
    for ( items in this.menus )
    {
        contextItems[items] = new MenuItem();
        contextItems[items].title = this.menus[items];
        contextItems[items].checked = (this.selected == this.menus[items]);
        contextItems[items].i = items;
        contextItems[items].data = this.menus[items];
        contextItems[items].onSelect = this.menuAction;		//  + '(' + items + ',"' +  this.menus[items] + '");';
    }
    popupMenu( contextItems, this.hOff, this.vOff );
    updateNow();
};
